; Modeless dialog box demo by Vortex

.386
.model flat,stdcall
option casemap:none

include    \GeneSys\include\windows.inc
include    \GeneSys\include\kernel32.inc
include    \GeneSys\include\user32.inc

includelib \GeneSys\lib\kernel32.lib
includelib \GeneSys\lib\user32.lib

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data

DlgBox  db 'DLGBOX',0

.data?

msg     MSG <?>
hDlg    dd ?

.code

start:

    invoke  GetModuleHandle,0
    invoke  CreateDialogParam,eax,ADDR DlgBox,0,ADDR DlgProc,0
    mov     hDlg,eax

    .WHILE TRUE

        invoke  GetMessage,ADDR msg,NULL,0,0

        .BREAK  .IF (!eax)

        invoke  IsDialogMessage,hDlg,ADDR msg

        .IF eax==FALSE

            invoke  TranslateMessage,ADDR msg
            invoke  DispatchMessage,ADDR msg

        .ENDIF

    .ENDW

    mov     eax,msg.wParam        
    invoke  ExitProcess,eax

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    .IF uMsg==WM_CLOSE
    
        invoke  DestroyWindow,hWnd

    .ELSEIF uMsg==WM_DESTROY

        invoke  PostQuitMessage,NULL

    .ELSE

        xor     eax,eax
        ret

    .ENDIF

    mov    eax,1
    ret

DlgProc ENDP

END start

